Column chooser in EJ2 JavaScript Treegrid control

1 Sep 202524 minutes to read

The column chooser has options to show or hide columns dynamically. It can be enabled by defining the showColumnChooser as true.

To use the column chooser, inject the Column Chooser module in the treegrid.

ej.treegrid.TreeGrid.Inject(ej.treegrid.ColumnChooser,ej.treegrid.Toolbar);


var treeGridObj = new ej.treegrid.TreeGrid({
    dataSource: sampleData,
    showColumnChooser: true,
    treeColumnIndex: 1,
    childMapping: 'subtasks',
    toolbar: ['ColumnChooser'],
    columns: [
        { field: 'taskID', headerText: 'Task ID', textAlign: 'Right', width: 90 },
        { field: 'taskName', headerText: 'Task Name', width: 240, showInColumnChooser: false },
        { field: 'startDate', headerText: 'Start Date', width: 110, format: 'yMd' },
        { field: 'endDate', headerText: 'End Date', width: 110, textAlign: 'Right', type: 'date', format: 'yMd' },
        { field: 'duration', headerText: 'Duration', width: 100, textAlign: 'Right' },
        { field: 'progress', headerText: 'Progress', width: 100, textAlign: 'Right' },
        { field: 'priority', headerText: 'Priority', width: 90 }
    ],
    height: 315
});

treeGridObj.appendTo('#TreeGrid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-treegrid/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-calendars/styles/material.css" rel="stylesheet">
    
    
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    
    
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="TreeGrid"></div>        
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

You can hide the column names in column chooser by defining the columns.showInColumnChooser as false.

Open column chooser by external button

The Column chooser can be displayed on a page through external button by invoking
the openColumnChooser method with X and Y axis positions.

ej.treegrid.TreeGrid.Inject(ej.treegrid.Toolbar, ej.treegrid.ColumnChooser);
var treeGridObj = new ej.treegrid.TreeGrid({
    dataSource: sampleData,
    showColumnChooser: true,
    treeColumnIndex: 1,
    childMapping: 'subtasks',
    treeColumnIndex: 1,
    columns: [
        { field: 'taskID', headerText: 'Task ID', textAlign: 'Right', width: 90 },
        { field: 'taskName', headerText: 'Task Name', width: 240, showInColumnChooser: false },
        { field: 'startDate', headerText: 'Start Date', width: 110, format: 'yMd' },
        { field: 'endDate', headerText: 'End Date', width: 110, textAlign: 'Right', type: 'date', format: 'yMd' },
        { field: 'duration', headerText: 'Duration', width: 100, textAlign: 'Right' },
        { field: 'progress', headerText: 'Progress', width: 100, textAlign: 'Right' },
        { field: 'priority', headerText: 'Priority', width: 90 }
    ],
    height: 315
});
treeGridObj.appendTo('#TreeGrid');
var show = new ej.buttons.Button({ cssClass: 'e-flat' }, '#show');

document.getElementById('show').onclick = function() {
    treeGridObj.columnChooserModule.openColumnChooser(200, 50); // give X and Y axis
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-treegrid/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-calendars/styles/material.css" rel="stylesheet">
    
    
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    
    
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <button id="show">Open Column Chooser</button>
        <div id="TreeGrid"></div>        
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Column chooser template in Syncfusion EJ2 JavaScript TreeGrid

The column chooser template feature allows full customization of the column chooser’s header, content, and footer, making it easier to manage column visibility. To enable the column chooser, set showColumnChooser to true and add ColumnChooser to the toolbar property.

To implement a custom column chooser template in the TreeGrid, use the following properties:

  • columnChooserSettings.headerTemplate - Defines the header template of the column chooser.

  • columnChooserSettings.template- Defines the content template.

  • columnChooserSettings.footerTemplate - Defines the footer template.

  • columnChooserSettings.renderCustomColumnChooser - Allows you to override the default column chooser UI with a fully customized layout.

In this example, a Syncfusion TreeView component is rendered inside the column chooser. To use the TreeView component, install the Syncfusion TreeView package as described in the documentation. The columnChooserSettings.template property defines a element with the id set to tree, providing as a container for the TreeView component. The columnChooserSettings.renderCustomColumnChooser method initializes the TreeView with checkboxes and appends it to this template. Checkbox selection is handled using the nodeClicked and keyPress events, which organize columns into Task Info, Schedule, and Progress.

The column chooser footer is customized using columnChooserSettings.footerTemplate, replacing the default buttons with customized Apply and Close buttons. The Apply button updates column visibility based on selection, while the Close button closes the column chooser via the onClick event. Additionally, the header is customized using columnChooserSettings.headerTemplate to include a title and an icon.

ej.treegrid.TreeGrid.Inject(ej.treegrid.Selection, ej.treegrid.Toolbar, ej.treegrid.ColumnChooser);

   var treeObj;
    function nodeCheck(args) {
        var checkedNode = [args.node];
        if (args.event.target.classList.contains('e-fullrow') || args.event.key == "Enter") {
            var getNodeDetails = treeObj.getNode(args.node);
            if (getNodeDetails.isChecked == 'true') {
                treeObj.uncheckAll(checkedNode);
            } else {
                treeObj.checkAll(checkedNode);
            }
        }
    }
    function renderCustomColumnChooser(targetLHTMLElement, columns) {
        var treeData;
    var parentNodes = [
        { id: 1, name: 'Task Info', hasChild: true, expanded: true },
        { id: 2, name: 'Schedule', hasChild: true, expanded: true },
        { id: 3, name: 'Progress', hasChild: true, expanded: true }
    ];
    if(columns && columns.length) {
    treeData = columns.map(function (column) {
        var parentId;
        switch (column.field) {
            case 'taskID':
            case 'taskName':
                parentId = 1;
                break;
            case 'startDate':
            case 'endDate':
                parentId = 2;
                break;
            case 'duration':
            case 'progress':
            case 'priority':
                parentId = 3;
                break;
        }
        return {
            id: column.uid,
            name: column.headerText,
            pid: parentId,
            isChecked: column.visible
        };
    });
            var uniquePids = [];
            treeData.forEach(function (item) {
                if (uniquePids.indexOf(item.pid) === -1) {
                    uniquePids.push(item.pid);
                }
            });
            var filteredParents = parentNodes.filter(function (parent) {
                return uniquePids.indexOf(parent.id) !== -1;
            });
            treeData = treeData.concat(filteredParents);
        } else {
            treeData = [];
        }
        treeObj = new ej.navigations.TreeView({
            fields: { dataSource: treeData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' },
            showCheckBox: true,
            nodeClicked: nodeCheck,
            keyPress: nodeCheck,
            enableRtl: treegrid.enableRtl ? true : false,
            cssClass: "no-border"
        });
        if (columns && columns.length) {
            treeObj.appendTo(targetLHTMLElement);
        } else {
            var noRecordDiv = document.createElement('div');
            noRecordDiv.innerHTML = 'No Matches Found';
            noRecordDiv.className = 'no-record-text';
            targetLHTMLElement.appendChild(noRecordDiv);
        }
    }
    var treegrid = new ej.treegrid.TreeGrid({
        dataSource: sampleData,
        childMapping: 'subtasks',
        height: 350,
        treeColumnIndex: 1,
        clipMode: 'EllipsisWithTooltip',
        showColumnChooser: true,
        allowPaging: true,
        toolbar: ['ColumnChooser'],
        columnChooserSettings: {
            headerTemplate: '#columnchooser-headertemplate', footerTemplate: '#columnchooser-footertemplate', enableSearching: true,
            template: '#column-chooser-template',
            renderCustomColumnChooser: renderCustomColumnChooser, ignoreAccent: true, operator: 'startsWith'
        },
        pageSettings: { pageCount: 5 },
    columns: [
        { field: 'taskID', headerText: 'Task ID', textAlign: 'Right', width: 90 },
        { field: 'taskName', headerText: 'Task Name', width: 240, showInColumnChooser: false },
        { field: 'startDate', headerText: 'Start Date', width: 110, format: 'yMd' },
        { field: 'endDate', headerText: 'End Date', width: 110, textAlign: 'Right', type: 'date', format: 'yMd' },
        { field: 'duration', headerText: 'Duration', width: 100, textAlign: 'Right' },
        { field: 'progress', headerText: 'Progress', width: 100, textAlign: 'Right' },
        { field: 'priority', headerText: 'Priority', width: 90 }
    ],
        created: onCreated
    });
    treegrid.appendTo('#TreeGrid');

    function onCreated() {
        var submitButton = new ej.buttons.Button();
        submitButton.appendTo('#submitButton');
        if (document.getElementById('submitButton')) {
            (document.getElementById('submitButton')).onclick = function (e) {
                columnChooserSubmit();
            };
        }
        var abortButton = new ej.buttons.Button();
        abortButton.appendTo('#abortButton');
        if (document.getElementById('abortButton')) {
            (document.getElementById('abortButton')).onclick = function (e) {
                (treegrid.grid.columnChooserModule).hideDialog();
            };
        }
    }

    function columnChooserSubmit() {
        var checkedElements = [];
        var uncheckedElements = [];
        var showColumns = treegrid.getVisibleColumns().filter(function (column) { return (column.showInColumnChooser === true); });
        showColumns = showColumns.map(function (col) { return col.headerText; });
        var treeItems = document.querySelectorAll('.e-list-item');

        treeItems.forEach(function (item) {
            var itemDetails = treeObj.getNode(item);
            if (!itemDetails.hasChildren) {
                if (item.getAttribute('aria-checked') === 'true') {
                    checkedElements.push(itemDetails.text);
                } else {
                    uncheckedElements.push(itemDetails.text);
                }
            }
        });
        showColumns = showColumns.filter(function (col) {
            return uncheckedElements.indexOf(col) === -1;
        });
        checkedElements.forEach(function (item) {
            if (!showColumns.includes(item)) {
                showColumns.push(item);
            }
        });
        var columnsToUpdate = { visibleColumns: showColumns, hiddenColumns: uncheckedElements };
        treegrid.grid.columnChooserModule.changeColumnVisibility(columnsToUpdate);
    }
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-treegrid/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

<div class="control-section">
    <div class="content-wrapper">
        <div id="container">
            <div id="TreeGrid"></div>
        </div>
    </div>
</div>
<script id="columnchooser-headertemplate" type="text/x-template">
<div>
    <span id="column-chooser-text">Column Options</span>
</div>
</script>
<script id="column-chooser-template" type="text/x-template">
      <div id="tree" ></div>
  </script>
<script id="columnchooser-footertemplate" type="text/x-template">
    <div id="columnChooserFooter">
        <button id="submitButton">Apply</button>
        <button id="abortButton">Close</button>
    </div>
</script>

<script>
    var ele = document.getElementById('container');
    if (ele) {
        ele.style.visibility = "visible";
    }   
</script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Column chooser in Angular TreeGrid component

2 Sep 202524 minutes to read

The column chooser feature in the Syncfusion® Angular TreeGrid component allows dynamic showing or hiding of columns. This feature can be enabled by setting the showColumnChooser property to true.

To use the column chooser, inject the ColumnChooserService in the provider section of AppModule.

import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService, ColumnChooserService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
    imports: [TreeGridModule],
    providers: [PageService, SortService, FilterService, ToolbarService, ColumnChooserService,],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid id="TreeGrid" [dataSource]='data' [toolbar]="toolbar" [treeColumnIndex]='1' [showColumnChooser]='true' height='270' childMapping='subtasks'>
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' width=90>
                        </e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                </ejs-treegrid>`,
})
export class AppComponent implements OnInit {
    public data: object[] = [];
    @ViewChild('treegrid')

    public treegrid?: TreeGridComponent;
    public toolbar?: string[];
    ngOnInit(): void {
        this.data = sampleData;
        this.toolbar = ['ColumnChooser'];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The column chooser dialog displays the header text of each column by default. If no header text is defined for a column, the corresponding column field name is displayed instead.

Hide column in column chooser dialog

Column names can be hidden in the column chooser by setting the column.showInColumnChooser property to false. This feature is useful when working with numerous columns or when limiting the columns available for selection in the column chooser dialog.

In this example, the column.showInColumnChooser property is set to false for the Task Name column. As a result, the Task Name column will not appear in the column chooser dialog.

import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService, ColumnChooserService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
    imports: [TreeGridModule],
    providers: [PageService, SortService, FilterService, ToolbarService, ColumnChooserService,],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid id="TreeGrid" [dataSource]='data' [toolbar]="toolbar" [treeColumnIndex]='1' [showColumnChooser]='true' height='270' childMapping='subtasks'>
                  <e-columns>
                    <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                    <e-column field='taskName' headerText='Task Name' textAlign='Left' [showInColumnChooser]='false' width=180></e-column>
                    <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                    <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' width=90>
                    </e-column>
                    <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                  </e-columns>
             </ejs-treegrid>`,
})
export class AppComponent implements OnInit {
    public data: object[] = [];
    @ViewChild('treegrid')

    public treegrid?: TreeGridComponent;
    public toolbar?: string[];
    ngOnInit(): void {
        this.data = sampleData;
        this.toolbar = ['ColumnChooser'];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The column.showInColumnChooser property is applied to each <e-column> element individually. Setting it to false hides specific columns from the column chooser dialog.

Open column chooser externally

The Syncfusion® Angular TreeGrid provides flexibility to open the column chooser dialog using an external button. By default, the column chooser button appears in the right corner of the TreeGrid component, and clicking it opens the column chooser dialog below. However, the column chooser dialog can be programmatically opened at specific X and Y axis positions using the openColumnChooser method.

The following example demonstrates opening the column chooser in the TreeGrid using an external button:

import { NgModule,ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService, ColumnChooserService, ToolbarService} from '@syncfusion/ej2-angular-treegrid'
import {ButtonModule} from '@syncfusion/ej2-angular-buttons'
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
imports: [TreeGridModule, ButtonModule ],
    providers: [PageService, SortService, FilterService, ToolbarService, ColumnChooserService,],
standalone: true,
    selector: 'app-container',
    template: `<button id='show' ej-button class='e-flat' (click)='show()'> open Column Chooser </button>
              
                <ejs-treegrid #treegrid id="TreeGrid" [dataSource]='data' [treeColumnIndex]='1' [showColumnChooser]='true' height='270' childMapping='subtasks'>
                     <e-columns>
                          <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                          <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                          <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                          <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' width=90>
                          </e-column>
                          <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                     </e-columns>
                 </ejs-treegrid>`,
})
export class AppComponent implements OnInit {

    public data: object[] = [];
    @ViewChild('treegrid')

    public treegrid?: TreeGridComponent;
    ngOnInit(): void {
        this.data = sampleData;
    }
    show() {
        (this.treegrid as TreeGridComponent).columnChooserModule.openColumnChooser(200, 50); // give X and Y axis
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize column chooser dialog size

The column chooser dialog in the Syncfusion® Angular TreeGrid comes with a default size, but the height and width can be modified according to specific requirements using CSS styles.

To customize the column chooser dialog size, use the following CSS styles:

.e-treegrid .e-dialog.e-ccdlg {
    height: 500px;
    width: 200px;
}
.e-treegrid .e-ccdlg .e-cc-contentdiv {
    height: 200px;
    width: 230px;
}
import { NgModule, ViewChild, ViewEncapsulation } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService, ColumnChooserService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
    imports: [TreeGridModule,],
    encapsulation:ViewEncapsulation.None,
    providers: [PageService, SortService, FilterService, ToolbarService, ColumnChooserService,],
    standalone: true,
    selector: 'app-container',
    template: ` <ejs-treegrid #treegrid id="TreeGrid" [dataSource]='data' [toolbar]="toolbar" [treeColumnIndex]='1' [showColumnChooser]='true' height='270' childMapping='subtasks'>
                    <e-columns>
                            <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                            <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                            <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                            <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' width=90>
                            </e-column>
                            <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                </ejs-treegrid>`,
    styles:[`.e-treegrid .e-dialog.e-ccdlg {
        height: 500px;
        width: 200px;
    }
    .e-treegrid .e-ccdlg .e-cc-contentdiv {
        height: 200px;
        width: 230px;
    }`]
})
export class AppComponent implements OnInit {
    public data: object[] = [];
    public toolbar?: string[];

    ngOnInit(): void {
        this.data = sampleData;
        this.toolbar = ['ColumnChooser'];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Change default search operator of the column chooser

The column chooser dialog in the Syncfusion® Angular TreeGrid provides a search box for searching column names. By default, the search functionality uses the “startsWith” operator to match columns and display results in the column chooser dialog. However, the default search operator can be changed to achieve more precise data matching.

To change the default search operator of the column chooser in the Syncfusion® TreeGrid, use the operator property of the columnChooserSettings through the grid property object of the TreeGrid instance in the load event.

The following example demonstrates changing the default search operator of the column chooser to contains in the TreeGrid:

import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService, ColumnChooserService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
    imports: [TreeGridModule],
    providers: [PageService, SortService, FilterService, ToolbarService, ColumnChooserService,],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid id="TreeGrid" [dataSource]='data' [toolbar]="toolbarOptions" [treeColumnIndex]='1' [showColumnChooser]='true' height='270' childMapping='subtasks' (load)=load($event)>
                   <e-columns>
                        <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' width=90>
                          </e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                 </ejs-treegrid>`,
})
export class AppComponent implements OnInit {
    public data: object[] = [];
    @ViewChild('treegrid')
    public treegrid?: TreeGridComponent;
    public toolbarOptions?: string[];

    ngOnInit(): void {
        this.data = sampleData;
        this.toolbarOptions = ['ColumnChooser'];
    }
    load(args: any) {
        (this.treegrid as TreeGridComponent).grid.columnChooserSettings = { operator: 'contains' };
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Diacritics searching in column chooser

By default, the TreeGrid ignores diacritic characters when performing a search in the column chooser. However, diacritic characters can be included in the search by setting the columnchoosersettings.ignoreAccent property to true through the grid property object of the TreeGrid instance with the load event.

The following example demonstrates using the ignoreAccent property to include diacritic characters for searching in the column chooser:

import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService, ColumnChooserService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';
import { ToolbarItems, GridComponent, ColumnChooserSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
    imports: [TreeGridModule,],
    providers: [PageService, SortService, FilterService, ToolbarService, ColumnChooserService,],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid id="TreeGrid" [dataSource]='data' [toolbar]="toolbarOptions" [treeColumnIndex]='1' [showColumnChooser]='true' height='270' childMapping='subtasks' (load)=load($event)>
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' width=90>
                          </e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                </ejs-treegrid>`,
})
export class AppComponent implements OnInit {
    public data: object[] = [];
    @ViewChild('treegrid')

    public treegrid?: TreeGridComponent;
    public toolbarOptions?: string[];
    ngOnInit(): void {
        this.data = sampleData;
        this.toolbarOptions = ['ColumnChooser'];
    }
    load(args: any) {
        (this.treegrid as TreeGridComponent).grid.columnChooserSettings = { ignoreAccent: true };
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Column Chooser Template in Syncfusion Angular TreeGrid component

The Column Chooser Template feature allows full customization of the column chooser’s header, content, and footer, making it easier to manage column visibility. To enable the column chooser, set showColumnChooser to true and add ColumnChooser to the toolbar property.

To implement a custom column chooser template in the TreeGrid, use the following properties:

  • columnChooserSettings.headerTemplate - Defines the header template of the column chooser.

  • columnChooserSettings.template- Defines the content template.

  • columnChooserSettings.footerTemplate - Defines the footer template.

  • columnChooserSettings.renderCustomColumnChooser - Allows you to override the default column chooser UI with a fully customized layout.

In this example, a Syncfusion TreeView component is rendered inside the column chooser. To use the TreeView component, install the Syncfusion TreeView package as described in the documentation. The columnChooserSettings.template property defines a element with the id set to tree, providing as a container for the TreeView component. The columnChooserSettings.renderCustomColumnChooser method initializes the TreeView with checkboxes and appends it to this template. Checkbox selection is handled using the nodeClicked and keyPress events, which organize columns into Task Info, Schedule, and Progress.

The column chooser footer is customized using columnChooserSettings.footerTemplate, replacing the default buttons with customized Apply and Close buttons. The Apply button updates column visibility based on selection, while the Close button closes the column chooser via the onClick event. Additionally, the header is customized using columnChooserSettings.headerTemplate to include a title and an icon.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridAllModule, TreeGridComponent, PageService, ToolbarService, ColumnChooserService } from '@syncfusion/ej2-angular-treegrid';
import { TreeViewModule, TreeView } from '@syncfusion/ej2-angular-navigations';
import { ButtonComponent, ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { NgIf } from '@angular/common';

@Component({
    selector: 'app-container',
    template: `<ejs-treegrid id="TreeGrid" #stackedHeadertreegrid clipMode="EllipsisWithTooltip" [dataSource]='data' childMapping='subtasks' height='350' [treeColumnIndex]='1' [allowPaging]=true [toolbar]="toolbar" [showColumnChooser]="true">
                        <e-columns>
                            <e-column field='taskID' headerText='Task ID' width='70' textAlign='Right'></e-column>
                            <e-column field='taskName' headerText='Task Name' width='200'></e-column>
                            <e-column field='startDate' headerText='Start Date' width='90' format="yMd" textAlign='Right'></e-column>
                            <e-column field='endDate' headerText='End Date' width='90' format="yMd" textAlign='Right'></e-column>
                            <e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
                            <e-column field='progress' headerText='Progress' width='80' textAlign='Right'></e-column>
                            <e-column field='priority' headerText='Priority' width='90'></e-column>
                        </e-columns>
                        
                    <!-- Custom Column Chooser Template using TreeView Component -->
                    <ng-template #columnChooserSettingsTemplate let-data>

                        <div *ngIf="!(data && data.columns && data.columns.length)" class="no-record-text">No Matches Found</div>
                        <div *ngIf="(data && data.columns && data.columns.length)" id="transparent">
                        <ejs-treeview #treeview id="treeview" cssClass="no-border" [fields]="dataProcess(data)" (nodeClicked)="nodeCheck($event)" (keyPress)="nodeCheck($event)" [showCheckBox]="true"></ejs-treeview>
                        </div>
                    </ng-template>
                    
                    <!-- Column Chooser Header Template -->
                    <ng-template #columnChooserSettingsHeaderTemplate>
                        <div>
                        <span id="column-chooser-text">Column Options</span>
                        </div>
                    </ng-template>
                    
                    <!-- Column Chooser Footer Template with Apply/Close Buttons -->
                    <ng-template #columnChooserSettingsFooterTemplate>
                        <button #applyBtn (click)="columnChooserSubmit()" ejs-button>Apply</button>
                        <button #closeBtn (click)="columnChooserClose()" ejs-button>Close</button>
                    </ng-template>            
                </ejs-treegrid>`,
    encapsulation: ViewEncapsulation.None,
    standalone: true,
    imports: [TreeGridAllModule, ButtonModule, TreeViewModule, NgIf],
    providers: [PageService, ToolbarService, ColumnChooserService],
})
export class AppComponent implements OnInit {
    public data: Object[] = [];
    public columnChooserSettings?: Object;

    @ViewChild('stackedHeadertreegrid')
    public treegrid?: TreeGridComponent | any;
    @ViewChild('treeview')
    public treeview?: TreeView | any;
    public toolbar?: string[];
    ngOnInit(): void {
        this.data = sampleData;
        this.toolbar = ['ColumnChooser'];
        this.columnChooserSettings = { enableSearching: true };

    }

    // Apply the column chooser selection
    columnChooserSubmit() {
        const treeGridInstance = (document.getElementById('TreeGrid') as any).ej2_instances[0];
        const checkedElements: any = [];
        const uncheckedElements: any = [];
        var showColumns = treeGridInstance.getVisibleColumns().filter(function (column: any) { return (column.showInColumnChooser === true); });
        showColumns = showColumns.map(function (col: any) { return col.headerText; });
        const treeItems = document.querySelectorAll('.e-list-item');
        treeItems.forEach(item => {
            const itemDetails = this.treeview.getNode(item);
            if (!itemDetails.hasChildren) {
                if (item.getAttribute('aria-checked') === 'true') {
                    checkedElements.push(itemDetails.text);
                } else {
                    uncheckedElements.push(itemDetails.text);
                }
            }
        });
        showColumns = showColumns.filter((col: any) => !uncheckedElements.includes(col));
        checkedElements.forEach((item: any) => {
            if (!showColumns.includes(item)) {
                showColumns.push(item);
            }
        });
        var columnsToUpdate = { visibleColumns: showColumns, hiddenColumns: uncheckedElements };
        treeGridInstance.grid.columnChooserModule.changeColumnVisibility(columnsToUpdate);
    };

    columnChooserClose() {
        const treeGridInstance = (document.getElementById('TreeGrid') as any).ej2_instances[0];
        treeGridInstance.grid.columnChooserModule.hideDialog();
    };

    // Render TreeView in the column chooser's Content
    dataProcess(args: any) {

        const parentNodes = [
            { id: 1, name: 'Task Info', hasChild: true, expanded: true },
            { id: 2, name: 'Schedule', hasChild: true, expanded: true },
            { id: 3, name: 'Progress', hasChild: true, expanded: true },
        ];
        let treeData = [];
        if (args.columns && args.columns.length) {
            treeData = args.columns.map((column: any) => {
                let parentId: number = 0;
                switch (column.field) {
                    case 'taskID':
                    case 'taskName':
                        parentId = 1;
                        break;
                    case 'startDate':
                    case 'endDate':
                        parentId = 2;
                        break;
                    case 'duration':
                    case 'progress':
                    case 'priority':
                        parentId = 3;
                        break;
                }
                return {
                    id: column.uid,
                    name: column.headerText,
                    pid: parentId,
                    isChecked: column.visible
                };
            });
            const uniquePids: any[] = [];
            treeData.forEach((item: any) => {
                if (!(uniquePids as any).includes(item.pid)) {
                    uniquePids.push(item.pid);
                }
            });
            const filteredParents = parentNodes.filter((parent: any) => (uniquePids as any).includes(parent.id));
            treeData.unshift(...filteredParents);
        } else {
            treeData = [];
        }

        const fields = { dataSource: treeData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };
        return fields;
    };
    
    // Handle checking/unchecking nodes in the TreeView (column chooser)
    nodeCheck(args: any) {
        let checkedNode = [args.node];
        if (args.event.target.classList.contains('e-fullrow') || args.event.key === "Enter") {
            let getNodeDetails = this.treeview.getNode(args.node);
            if (getNodeDetails.isChecked === 'true') {
                this.treeview.uncheckAll(checkedNode);
            } else {
                this.treeview.checkAll(checkedNode);
            }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Column Chooser in Vue Treegrid component

2 Sep 202524 minutes to read

Column Chooser Template in Syncfusion Vue TreeGrid component

The Column Chooser Template feature allows full customization of the column chooser’s header, content, and footer, making it easier to manage column visibility. To enable the column chooser, set showColumnChooser to true and add ColumnChooser to the toolbar property.

To implement a custom column chooser template in the TreeGrid, use the following properties:

  • columnChooserSettings.headerTemplate - Defines the header template of the column chooser.

  • columnChooserSettings.template- Defines the content template.

  • columnChooserSettings.footerTemplate - Defines the footer template.

  • columnChooserSettings.renderCustomColumnChooser - Allows you to override the default column chooser UI with a fully customized layout.

In this example, a Syncfusion TreeView component is rendered inside the column chooser. To use the TreeView component, install the Syncfusion TreeView package as described in the documentation. The columnChooserSettings.template property is used to render the TreeView component with checkboxes.Checkbox selection is handled using the nodeClicked and keyPress events, which organize columns into Order Details, Shipping Details, and Delivery Status.

The column chooser footer is customized using columnChooserSettings.footerTemplate, replacing the default buttons with customized Apply and Close buttons. The Apply button updates column visibility based on selection, while the Close button closes the column chooser via the onClick event. Additionally, the header is customized using columnChooserSettings.headerTemplate to include a title and an icon.

```vue
<template>
  <div id="app">
    <ejs-treegrid
      ref="gridInstance"
      id="gridInstance"
      :toolbar="toolbar"
      :dataSource="data"
      childMapping="subtasks"
      :height="350"
      :showColumnChooser="true"
      :columnChooserSettings="columnChooserSettings"
      :treeColumnIndex="1"
      :allowPaging="true"
      clipMode="EllipsisWithTooltip"
    >
      <e-columns>
        <e-column headerText="Order Details" :columns="orderColumns" textAlign="Center"></e-column>
        <e-column headerText="Shipment Details" :columns="shipColumns" textAlign="Center"></e-column>
        <e-column headerText="Price Details" :columns="priceColumns" textAlign="Center"></e-column>
      </e-columns>

      <!-- Custom Column Chooser Template using TreeView Component -->
      <template v-slot:template="{ data }">
        <div v-if="data && data.columns && data.columns.length">
          <ejs-treeview
            id="treeview"
            :fields="dataProcess(data)"
            cssClass="no-border"
            :showCheckBox="true"
            :keyPress="nodeCheck"
            :nodeClicked="nodeCheck"
          ></ejs-treeview>
        </div>
        <div v-else class="no-record-text">No Matches Found</div>
      </template>

      <!-- Column Chooser Header Template -->
      <template v-slot:headerTemplate>
        <div>
          <span id="column-chooser-text">Column Options</span>
        </div>
      </template>

      <!-- Column Chooser Footer Template with Apply/Close Buttons -->
      <template v-slot:footerTemplate>
        <ejs-button v-on:click="columnChooserSubmit">Apply</ejs-button>
        <ejs-button v-on:click="columnChooserClose">Close</ejs-button>
      </template>
    </ejs-treegrid>
  </div>
</template>

<script setup>
import { ref } from "vue";
import { TreeViewComponent } from "@syncfusion/ej2-vue-navigations";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
import { TreeGridComponent, ColumnDirective, ColumnsDirective, Page, ColumnChooser, Toolbar } from "@syncfusion/ej2-vue-treegrid";
import { stackedData } from "./datasource";

// Reactive state
const data = ref(stackedData);
const toolbar = ref(['ColumnChooser']);
const columnChooserSettings = ref({
  enableSearching: true,
  template: 'template',
  headerTemplate: 'headerTemplate',
  footerTemplate: 'footerTemplate'
});
const gridInstance = ref(null);

const orderColumns = ref([
  { field: 'orderID', headerText: 'Order ID', textAlign: 'Right', width: 90, showInColumnChooser: false },
  { field: 'orderName', headerText: 'Order Name', textAlign: 'Left', width: 180 },
  { field: 'orderDate', headerText: 'Order Date', textAlign: 'Right', format: 'yMd', width: 120 }
]);

const shipColumns = ref([
  { field: 'shipMentCategory', headerText: 'Shipment Category', textAlign: 'Left', width: 150 },
  { field: 'shippedDate', headerText: 'Shipped Date', textAlign: 'Right', format: 'yMd', width: 120 },
  { field: 'units', headerText: 'Units', textAlign: 'Right', width: 90 }
]);

const priceColumns = ref([
  { field: 'unitPrice', headerText: 'Price per unit ($)', width: 150, format: 'c2', textAlign: 'Right' },
  { field: 'price', headerText: 'Total Price ($)', width: 120, format: 'c', textAlign: 'Right' }
]);

// Handle checking/unchecking nodes in the TreeView (column chooser)
const nodeCheck = (args) => {
  const checkedNode = [args.node];
  const treeObj = document.getElementById('treeview')?.ej2_instances[0];
  if (!treeObj) return;

  if (args.event.target.classList.contains('e-fullrow') || args.event.key === "Enter") {
    const getNodeDetails = treeObj.getNode(args.node);
    if (getNodeDetails.isChecked === 'true') {
      treeObj.uncheckAll(checkedNode);
    } else {
      treeObj.checkAll(checkedNode);
    }
  }
};

// Render TreeView in the column chooser's content
const dataProcess = (args) => {
  const parentNodes = [
    { id: 1, name: 'Order Details', hasChild: true, expanded: true },
    { id: 2, name: 'Shipment Details', hasChild: true, expanded: true },
    { id: 3, name: 'Price Details', hasChild: true, expanded: true }
  ];

  let treeData = [];
  if (args.columns && args.columns.length) {
    treeData = args.columns.map((column) => {
      let parentId;
      switch (column.field) {
        case 'orderID':
        case 'orderName':
        case 'orderDate':
          parentId = 1;
          break;
        case 'shipMentCategory':
        case 'shippedDate':
        case 'units':
          parentId = 2;
          break;
        case 'unitPrice':
        case 'price':
          parentId = 3;
          break;
        default:
          break;
      }
      return {
        id: column.uid,
        name: column.headerText,
        pid: parentId,
        isChecked: column.visible
      };
    });

    const uniquePids = [];
    treeData.forEach((item) => {
      if (uniquePids.indexOf(item.pid) === -1) {
        uniquePids.push(item.pid);
      }
    });
    const filteredParents = parentNodes.filter((parent) => uniquePids.indexOf(parent.id) !== -1);
    treeData.push(...filteredParents);
  }

  return { dataSource: treeData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };
};

// Close the column chooser dialog
const columnChooserClose = () => {
  const gridObj = gridInstance.value?.ej2_instances[0];
  if (gridObj) {
    gridObj.grid.columnChooserModule.hideDialog();
  }
};

// Apply the column chooser selection
const columnChooserSubmit = () => {
  const checkedElements = [];
  const uncheckedElements = [];
  const gridObj = gridInstance.value?.ej2_instances[0];
  const treeObj = document.getElementById('treeview')?.ej2_instances[0];

  if (!gridObj || !treeObj) {
    gridObj?.grid.columnChooserModule.hideDialog();
    return;
  }

  const showColumns = gridObj.getVisibleColumns().filter((column) => column.showInColumnChooser === true).map((col) => col.headerText);
  const treeItems = document.querySelectorAll('.e-list-item');

  treeItems.forEach((item) => {
    const itemDetails = treeObj.getNode(item);
    if (!itemDetails.hasChildren) {
      if (item.getAttribute('aria-checked') === 'true') {
        checkedElements.push(itemDetails.text);
      } else {
        uncheckedElements.push(itemDetails.text);
      }
    }
  });

  const updatedShowColumns = showColumns.filter((col) => !uncheckedElements.includes(col));
  checkedElements.forEach((item) => {
    if (!updatedShowColumns.includes(item)) {
      updatedShowColumns.push(item);
    }
  });

  const columnsToUpdate = { visibleColumns: updatedShowColumns, hiddenColumns: uncheckedElements };
  gridObj.grid.columnChooserModule.changeColumnVisibility(columnsToUpdate);
};

// Provide dependencies
provide('treegrid', [Page, Toolbar, ColumnChooser]);
</script>
```
<template>
<div id="app">
  <div class="col-lg-12 control-section">
    <div>
        <ejs-treegrid ref='gridInstance' id='gridInstance' :toolbar='toolbar'  :dataSource='data' childMapping='subtasks' :height='350' :showColumnChooser='true' :columnChooserSettings='columnChooserSettings' :treeColumnIndex='1' :allowPaging='true' clipMode='EllipsisWithTooltip'>
            <e-columns>
                <e-column headerText='Order Details' :columns='orderColumns' textAlign='Center'></e-column>
                <e-column headerText='Shipment Details' :columns='shipColumns' textAlign='Center'></e-column>
                <e-column headerText='Price Details' :columns='priceColumns' textAlign='Center'></e-column>
            </e-columns>
            
            <!-- Custom Column Chooser Template using TreeView Component -->
            <template v-slot:template="{data}">
                <div  v-if="data && data.columns && data.columns.length">
                    <ejs-treeview id='treeview' :fields='dataProcess(data)' cssClass="no-border"  :showCheckBox='true' :keyPress='nodeCheck' :nodeClicked='nodeCheck'></ejs-treeview>
                </div>
                <div v-else class="no-record-text">No Matches Found</div>
            </template>

            <!-- Column Chooser Header Template -->
            <template v-slot:headerTemplate>
                <div>
                    <span id="column-chooser-text">Column Options</span>
                </div>
            </template>
            
            <!-- Column Chooser Footer Template with Apply/Close Buttons -->
            <template v-slot:footerTemplate>
                <ejs-button v-on:click='columnChooserSubmit'>Apply</ejs-button>
                <ejs-button v-on:click='columnChooserClose'>Close</ejs-button>
            </template>
        </ejs-treegrid>
    </div>
</div>
</div>
</template>
<script>
import { TreeViewComponent } from "@syncfusion/ej2-vue-navigations";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
import { TreeGridComponent, ColumnDirective, ColumnsDirective, Page, ColumnChooser, Toolbar, } from "@syncfusion/ej2-vue-treegrid";
import { stackedData } from "./datasource";

export default {
  components: {
    'ejs-treegrid': TreeGridComponent,
    'e-column': ColumnDirective,
    'e-columns': ColumnsDirective,
    'ejs-button': ButtonComponent,
    "ejs-treeview": TreeViewComponent,
  },  
  data: () => {
    return {
      data: stackedData,
      toolbar: ['ColumnChooser'],
      columnChooserSettings: { enableSearching: true, template: 'template', headerTemplate: 'headerTemplate', footerTemplate: 'footerTemplate' },
     
          
      orderColumns : [
            { field: 'orderID', headerText: 'Order ID', textAlign: 'Right', width: 90, showInColumnChooser: false },
            { field: 'orderName', headerText: 'Order Name', textAlign: 'Left', width: 180 },
            { field: 'orderDate', headerText: 'Order Date', textAlign: 'Right', format: 'yMd', width: 120 }
        ],
        shipColumns : [
            { field: 'shipMentCategory', headerText: 'Shipment Category', textAlign: 'Left', width: 150 },
            { field: 'shippedDate', headerText: 'Shipped Date', textAlign: 'Right', format: 'yMd', width: 120 },
            { field: 'units', headerText: 'Units', textAlign: 'Right', width: 90 }
        ],
        priceColumns : [
            { field: 'unitPrice', headerText: 'Price per unit ($)', width: 150, format: 'c2', textAlign: 'Right' },
            { field: 'price', headerText: 'Total Price ($)', width: 120, format: 'c', textAlign: 'Right' }
        ]
    };
  },
   provide : {
      treegrid: [ Page, Toolbar, ColumnChooser],
    },
    methods :{
        // Handle checking/unchecking nodes in the TreeView (column chooser)
        nodeCheck: function (args){
            let checkedNode = [args.node];
            var treeObj = (document.getElementById('treeview')).ej2_instances[0];
            if (args.event.target.classList.contains('e-fullrow') || args.event.key == "Enter") {
            let getNodeDetails = treeObj.getNode(args.node);
                if (getNodeDetails.isChecked == 'true') {
                    treeObj.uncheckAll(checkedNode);
                } else {
                    treeObj.checkAll(checkedNode);
                }
            }
        },
        // Render TreeView in the column chooser's Content
        dataProcess: function (args) {
            const parentNodes = [
            { id: 1, name: 'Order Details', hasChild: true, expanded: true },
            { id: 2, name: 'Shipment Details', hasChild: true, expanded: true },
            { id: 3, name: 'Price Details', hasChild: true, expanded: true },   
        ];
            let treeData = [];
            if (args.columns && args.columns.length) {
            treeData = args.columns.map((column) => {
                let parentId;
                switch (column.field) {
                    case 'orderID':
                    case 'orderName':
                    case 'orderDate':
                    parentId = 1;
                    break;
                case 'shipMentCategory':
                case 'shippedDate':
                case 'units':
                    parentId = 2;
                    break;
                    case 'unitPrice':
                case 'price':
                
                    parentId = 3;
                    break;
                    default :
                        break;
                }
                return {
                id: column.uid,
                name: column.headerText,
                pid: parentId,
                isChecked: column.visible
                };
            });
            const uniquePids = [];
            treeData.forEach((item) => {
                if (uniquePids.indexOf(item.pid) === -1) {
                    uniquePids.push(item.pid);
                }
            });
            const filteredParents = parentNodes.filter((parent) => uniquePids.indexOf(parent.id) !== -1);
            treeData.push(...filteredParents);
            } else {
                treeData = [];
            }
            const fields = { dataSource: treeData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };
            return fields;
        },
        columnChooserClose: function(){
            var gridInstance = (document.getElementById('gridInstance')).ej2_instances[0];
            gridInstance.grid.columnChooserModule.hideDialog();
        },
        // Apply the column chooser selection
        columnChooserSubmit: function (){
            const checkedElements = [];
            const uncheckedElements = []; 
            var gridInstance = (document.getElementById('gridInstance')).ej2_instances[0];
            if((document.getElementById('treeview')) != null){
            var treeObj = (document.getElementById('treeview')).ej2_instances[0];
            }
            var showColumns = gridInstance.getVisibleColumns().filter(function (column) { return (column.showInColumnChooser === true); });
            showColumns = showColumns.map(function (col) { return col.headerText; });
            const treeItems = document.querySelectorAll('.e-list-item');
            if(treeObj != null || treeObj != undefined){
            treeItems.forEach(item => {
                const itemDetails = treeObj.getNode(item);
                if (!itemDetails.hasChildren) {
                    if (item.getAttribute('aria-checked') === 'true') {
                    checkedElements.push(itemDetails.text);
                } else {
                    uncheckedElements.push(itemDetails.text);
                }
                }
            });
            showColumns = showColumns.filter((col) => uncheckedElements.indexOf(col) === -1);
            checkedElements.forEach(item => {
                if (!showColumns.includes(item)) {
                    showColumns.push(item);
                }
            });
            var columnsToUpdate = { visibleColumns: showColumns, hiddenColumns: uncheckedElements };
            gridInstance.grid.columnChooserModule.changeColumnVisibility(columnsToUpdate);
            }
            else{
                gridInstance.grid.columnChooserModule.hideDialog();
            }
        },
    }

}
</script>

Column Chooser in React Treegrid component

13 Apr 202624 minutes to read

Column Chooser Template in Syncfusion React TreeGrid

The Column Chooser Template feature enables full customization of the column chooser header, content, and footer to manage column visibility. To enable the column chooser, set showColumnChooser to true and include ColumnChooser in the toolbar property.

To implement a custom column chooser template in the TreeGrid, use the following properties:

  • columnChooserSettings.headerTemplate: Defines the header template.
  • columnChooserSettings.template: Defines the content template.
  • columnChooserSettings.footerTemplate: Defines the footer template.

In this example, the Syncfusion TreeView component is rendered inside the column chooser. To use the TreeView component, install the Syncfusion TreeView package as described in the TreeView getting started documentation. The columnChooserSettings.template property renders the TreeView with checkboxes. Checkbox selection is handled using the nodeClicked and keyPress events, organizing columns into Order Details, Shipping Details, and Delivery Status.

The column chooser footer is customized using columnChooserSettings.footerTemplate, replacing default buttons with customized Apply and Close buttons. The Apply button updates column visibility based on the selected nodes, and the Close button dismisses the dialog via the onClick event. The header is customized using columnChooserSettings.headerTemplate to include a title and an icon.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { TreeGridComponent, ColumnsDirective, ColumnDirective, Page, Toolbar, ColumnChooser, ToolbarItems, Inject } from '@syncfusion/ej2-react-treegrid';
import { stackedData } from './datasource';
import { TreeView, TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {
    const toolbar = ['ColumnChooser'];
  const columnChooserSettings = { template: Template, headerTemplate: HeaderTemplate, footerTemplate: FooterTemplate }
  function HeaderTemplate() {
    return (
      <div>
        <span id="column-chooser-text" style=>Column Options</span>
      </div>
    );
  }

  // Render TreeView in the column chooser's Content
  function Template(props) {
    const parentNodes = [
      { id: 1, name: 'Order Details', hasChild: true, expanded: true },
      { id: 2, name: 'Shipment Details', hasChild: true, expanded: true },
      { id: 3, name: 'Price Details', hasChild: true, expanded: true },
    ];
    let treeData = [];

    if (props.columns && props.columns.length) {
      treeData = props.columns.map((column) => {
        let parentId;
        switch (column.field) {
          case 'orderID':
          case 'orderName':
          case 'orderDate':
            parentId = 1;
            break;
          case 'shipMentCategory':
          case 'shippedDate':
          case 'units':
            parentId = 2;
            break;
          case 'unitPrice':
          case 'price':

            parentId = 3;
            break;
          default:
            break;
        }
        return {
          id: column.uid,
          name: column.headerText,
          pid: parentId,
          isChecked: column.visible
        };
      });
      const uniquePids = [];
      treeData.forEach((item) => {
        if (!uniquePids.includes(item.pid)) {
          uniquePids.push(item.pid);
        }
      });
      const filteredParents = parentNodes.filter((parent) => uniquePids.includes(parent.id));
      treeData.push(...filteredParents);
    } else {
      treeData = [];
    }

    const fields = { dataSource: treeData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };


    return (
      <div>

        {props.columns && props.columns.length ? (<TreeViewComponent fields={fields} cssClass="no-border" showCheckBox={true} nodeClicked={nodeCheck} keyPress={nodeCheck} ref={(treeview ) => { treeObj = treeview; }} />) : (<div className="no-record-text">No Matches Found</div>)}
      </div>
    );
  }

  function FooterTemplate() {
    return (
      <div id="columnChooserFooter">
        <ButtonComponent onClick={columnChooserSubmit}>Apply</ButtonComponent>
        <ButtonComponent onClick={columnChooserClose}>Close</ButtonComponent>
      </div>
    );
  }

  // Handle checking/unchecking nodes in the TreeView (column chooser)
  function nodeCheck(args) {
    let checkedNode = [args.node];
    if (args.event.target.classList.contains('e-fullrow') || args.event.key == "Enter") {
      let getNodeDetails = treeObj.getNode(args.node);
      if (getNodeDetails.isChecked == 'true') {
        treeObj.uncheckAll(checkedNode);
      } else {
        treeObj.checkAll(checkedNode);
      }
    }
  }
  function columnChooserClose() {
    (treegridInstance.grid.columnChooserModule).hideDialog();
  }

  // Apply the column chooser selection
  function columnChooserSubmit() {
    const checkedElements = [];
    const uncheckedElements = [];
    var showColumns = treegridInstance.getVisibleColumns().filter(function (column) { return (column.showInColumnChooser === true); });
    showColumns = showColumns.map(function (col) { return col.headerText; });
    const treeItems = document.querySelectorAll('.e-list-item');

    treeItems.forEach(item => {
      const itemDetails = treeObj.getNode(item);
      if (!itemDetails.hasChildren) {
        if (item.getAttribute('aria-checked') === 'true') {
          checkedElements.push(itemDetails.text);
        } else {
          uncheckedElements.push(itemDetails.text);
        }
      }
    });
    showColumns = showColumns.filter((col) => !uncheckedElements.includes(col));
    checkedElements.forEach((item) => {
      if (!showColumns.includes(item)) {
        showColumns.push(item);
      }
    });
    var columnsToUpdate = { visibleColumns: showColumns, hiddenColumns: uncheckedElements };
    treegridInstance.grid.columnChooserModule.changeColumnVisibility(columnsToUpdate);
  }
  let treeObj;
  let treegridInstance;
  return (
    <div className="control-pane">
      <div className="control-section">
        <TreeGridComponent
          dataSource={stackedData}
          id="TreeGrid"
          ref={(treegrid ) => { treegridInstance = treegrid }}
          treeColumnIndex={1}
          childMapping="subtasks"
          height="350"
          allowPaging={true}
          pageSettings=
          showColumnChooser={true}
          columnChooserSettings={columnChooserSettings}
          toolbar={toolbar}
          clipMode='EllipsisWithTooltip'
        >
          <ColumnsDirective>
            <ColumnDirective
              columns={[
                {
                  field: "orderID",
                  headerText: "Order ID",
                  width: 90,
                  textAlign: "Right",
                  showInColumnChooser: false,
                },
                {
                  field: "orderName",
                  headerText: "Order Name",
                  width: 190,
                  textAlign: "Left",
                },
                {
                  field: "orderDate",
                  headerText: "Order Date",
                  width: 110,
                  textAlign: "Right",
                  format: "yMd",
                },
              ]}
              headerText="Order Details"
              textAlign="Center"
            ></ColumnDirective>
            <ColumnDirective
              columns={[
                {
                  field: "shipMentCategory",
                  headerText: "Shipment Category",
                  width: 150,
                  textAlign: "Left",
                },
                {
                  field: "shippedDate",
                  headerText: "Shipped Date",
                  width: 120,
                  textAlign: "Right",
                  format: "yMd",
                },
                {
                  field: "units",
                  headerText: "Units",
                  width: 80,
                  textAlign: "Right",
                },
              ]}
              headerText="Shipment Details"
              textAlign="Center"
            ></ColumnDirective>
            <ColumnDirective
              columns={[
                {
                  field: "unitPrice",
                  headerText: "Price per unit",
                  format: "C2",
                  type: "number",
                  textAlign: "Right",
                  width: 120,
                },
                {
                  field: "price",
                  headerText: "Total Price",
                  width: 115,
                  format: "C",
                  textAlign: "Right",
                  type: "number",
                },
              ]}
              headerText="Price Details"
              textAlign="Center"
            ></ColumnDirective>
          </ColumnsDirective>
          <Inject services={[Page, Toolbar, ColumnChooser,]} />
        </TreeGridComponent>
      </div>
    </div>
  );
};
export default App;
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { TreeGridComponent, ColumnsDirective, ColumnDirective, Page, Toolbar, ColumnChooser, ToolbarItems, Inject } from '@syncfusion/ej2-react-treegrid';
import { stackedData } from './datasource';
import { TreeView, TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {
    const toolbar: any = ['ColumnChooser'];
  const columnChooserSettings: any = { template: Template, headerTemplate: HeaderTemplate, footerTemplate: FooterTemplate }
  function HeaderTemplate(): any {
    return (
      <div>
        <span id="column-chooser-text" style=>Column Options</span>
      </div>
    );
  }

  // Render TreeView in the column chooser's Content
  function Template(props: any): any {
    const parentNodes = [
      { id: 1, name: 'Order Details', hasChild: true, expanded: true },
      { id: 2, name: 'Shipment Details', hasChild: true, expanded: true },
      { id: 3, name: 'Price Details', hasChild: true, expanded: true },
    ];
    let treeData: { [key: string]: Object }[] = [];

    if (props.columns && props.columns.length) {
      treeData = props.columns.map((column: any) => {
        let parentId: any;
        switch (column.field) {
          case 'orderID':
          case 'orderName':
          case 'orderDate':
            parentId = 1;
            break;
          case 'shipMentCategory':
          case 'shippedDate':
          case 'units':
            parentId = 2;
            break;
          case 'unitPrice':
          case 'price':

            parentId = 3;
            break;
          default:
            break;
        }
        return {
          id: column.uid,
          name: column.headerText,
          pid: parentId,
          isChecked: column.visible
        };
      });
      const uniquePids: string[] = [];
      treeData.forEach((item: any) => {
        if (!uniquePids.includes(item.pid)) {
          uniquePids.push(item.pid);
        }
      });
      const filteredParents = parentNodes.filter((parent: any) => uniquePids.includes(parent.id));
      treeData.push(...filteredParents);
    } else {
      treeData = [];
    }

    const fields = { dataSource: treeData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };


    return (
      <div>

        {props.columns && props.columns.length ? (<TreeViewComponent fields={fields} cssClass="no-border" showCheckBox={true} nodeClicked={nodeCheck} keyPress={nodeCheck} ref={(treeview : any) => { treeObj = treeview; }} />) : (<div className="no-record-text">No Matches Found</div>)}
      </div>
    );
  }

  function FooterTemplate(): any {
    return (
      <div id="columnChooserFooter">
        <ButtonComponent onClick={columnChooserSubmit}>Apply</ButtonComponent>
        <ButtonComponent onClick={columnChooserClose}>Close</ButtonComponent>
      </div>
    );
  }

  // Handle checking/unchecking nodes in the TreeView (column chooser)
  function nodeCheck(args: any): void {
    let checkedNode: any = [args.node];
    if (args.event.target.classList.contains('e-fullrow') || args.event.key == "Enter") {
      let getNodeDetails: any = treeObj.getNode(args.node);
      if (getNodeDetails.isChecked == 'true') {
        treeObj.uncheckAll(checkedNode);
      } else {
        treeObj.checkAll(checkedNode);
      }
    }
  }
  function columnChooserClose() {
    (treegridInstance.grid.columnChooserModule as any).hideDialog();
  }

  // Apply the column chooser selection
  function columnChooserSubmit() {
    const checkedElements: any = [];
    const uncheckedElements: any = [];
    var showColumns: any = treegridInstance.getVisibleColumns().filter(function (column: any) { return (column.showInColumnChooser === true); });
    showColumns = showColumns.map(function (col: any) { return col.headerText; });
    const treeItems = document.querySelectorAll('.e-list-item');

    treeItems.forEach(item => {
      const itemDetails = treeObj.getNode(item);
      if (!itemDetails.hasChildren) {
        if (item.getAttribute('aria-checked') === 'true') {
          checkedElements.push(itemDetails.text);
        } else {
          uncheckedElements.push(itemDetails.text);
        }
      }
    });
    showColumns = showColumns.filter((col: any) => !uncheckedElements.includes(col));
    checkedElements.forEach((item :any) => {
      if (!showColumns.includes(item)) {
        showColumns.push(item);
      }
    });
    var columnsToUpdate: any = { visibleColumns: showColumns, hiddenColumns: uncheckedElements };
    treegridInstance.grid.columnChooserModule.changeColumnVisibility(columnsToUpdate);
  }
  let treeObj: TreeView;
  let treegridInstance: TreeGridComponent;
  return (
    <div className="control-pane">
      <div className="control-section">
        <TreeGridComponent
          dataSource={stackedData}
          id="TreeGrid"
          ref={(treegrid :any) => { treegridInstance = treegrid }}
          treeColumnIndex={1}
          childMapping="subtasks"
          height="350"
          allowPaging={true}
          pageSettings=
          showColumnChooser={true}
          columnChooserSettings={columnChooserSettings}
          toolbar={toolbar}
          clipMode='EllipsisWithTooltip'
        >
          <ColumnsDirective>
            <ColumnDirective
              columns={[
                {
                  field: "orderID",
                  headerText: "Order ID",
                  width: 90,
                  textAlign: "Right",
                  showInColumnChooser: false,
                },
                {
                  field: "orderName",
                  headerText: "Order Name",
                  width: 190,
                  textAlign: "Left",
                },
                {
                  field: "orderDate",
                  headerText: "Order Date",
                  width: 110,
                  textAlign: "Right",
                  format: "yMd",
                },
              ]}
              headerText="Order Details"
              textAlign="Center"
            ></ColumnDirective>
            <ColumnDirective
              columns={[
                {
                  field: "shipMentCategory",
                  headerText: "Shipment Category",
                  width: 150,
                  textAlign: "Left",
                },
                {
                  field: "shippedDate",
                  headerText: "Shipped Date",
                  width: 120,
                  textAlign: "Right",
                  format: "yMd",
                },
                {
                  field: "units",
                  headerText: "Units",
                  width: 80,
                  textAlign: "Right",
                },
              ]}
              headerText="Shipment Details"
              textAlign="Center"
            ></ColumnDirective>
            <ColumnDirective
              columns={[
                {
                  field: "unitPrice",
                  headerText: "Price per unit",
                  format: "C2",
                  type: "number",
                  textAlign: "Right",
                  width: 120,
                },
                {
                  field: "price",
                  headerText: "Total Price",
                  width: 115,
                  format: "C",
                  textAlign: "Right",
                  type: "number",
                },
              ]}
              headerText="Price Details"
              textAlign="Center"
            ></ColumnDirective>
          </ColumnsDirective>
          <Inject services={[Page, Toolbar, ColumnChooser,]} />
        </TreeGridComponent>
      </div>
    </div>
  );
};
export default App;